#! /bin/sh

# 2.2 and 2.4-style kernels will have query_syscall, and /proc/ksyms
MODTEST_OVERRIDE0=/proc/ksyms
MODTEST_OVERRIDE_WITH0=/dev/null

MODTEST_DO_QUERY_MODULE=1
export MODTEST_DO_QUERY_MODULE

# Should fail to run (sys_query_module succeeds), not find insmod.old.
[ "`./insmod 2>&1`" = "Kernel requires old insmod, but couldn't run ./insmod.old: No such file or directory" ]

unset MODTEST_DO_QUERY_MODULE

# sys_query_module fails, but /proc/ksyms "found", 2.0-style.
[ "`./insmod 2>&1`" = "Kernel requires old insmod, but couldn't run ./insmod.old: No such file or directory" ]

# Create one for it to find, put it in the path
echo '#! /bin/sh' > tests/tmp/insmod.old
echo 'echo -n INSMOD.OLD' >> tests/tmp/insmod.old
echo "for f; do echo -n \ \'\$f\'; done" >> tests/tmp/insmod.old
chmod a+x tests/tmp/insmod.old
PATH=`pwd`/tests/tmp:$PATH

# If explicit path given, shouldn't search path.
[ "`./insmod 2>&1`" = "Kernel requires old insmod, but couldn't run ./insmod.old: No such file or directory" ]

# No args expected
[ "`insmod`" = "INSMOD.OLD" ]

# Args intact
[ "`insmod --some-wierd-option foo`" = "INSMOD.OLD '--some-wierd-option' 'foo'" ]

