#! /bin/sh

# 2.2 and 2.4-style kernels will have query_syscall, and /proc/ksyms
MODTEST_OVERRIDE0=/proc/ksyms
MODTEST_OVERRIDE_WITH0=/dev/null

MODTEST_DO_QUERY_MODULE=1
export MODTEST_DO_QUERY_MODULE

# Should fail to run (sys_query_module succeeds), not find rmmod.old.
[ "`./rmmod 2>&1`" = "Kernel requires old rmmod, but couldn't run ./rmmod.old: No such file or directory" ]

unset MODTEST_DO_QUERY_MODULE

# sys_query_module fails, but /proc/ksyms "found", 2.0-style.
[ "`./rmmod 2>&1`" = "Kernel requires old rmmod, but couldn't run ./rmmod.old: No such file or directory" ]

# Create one for it to find, put it in the path
echo '#! /bin/sh' > tests/tmp/rmmod.old
echo 'echo -n RMMOD.OLD' >> tests/tmp/rmmod.old
echo "for f; do echo -n \ \'\$f\'; done" >> tests/tmp/rmmod.old
chmod a+x tests/tmp/rmmod.old
PATH=`pwd`/tests/tmp:$PATH

# If explicit path given, shouldn't search path.
[ "`./rmmod 2>&1`" = "Kernel requires old rmmod, but couldn't run ./rmmod.old: No such file or directory" ]

# No args expected
[ "`rmmod 2>&1`" = "RMMOD.OLD" ]

# Args intact
[ "`rmmod --some-wierd-option foo 2>&1`" = "RMMOD.OLD '--some-wierd-option' 'foo'" ]

